def lunar_arithmetic(a, b):
    def to_digits(n):
        return [int(d) for d in str(n)]

    def from_digits(digits):
        return int(''.join(map(str, digits)))

    def lunar_sum(digits_a, digits_b):
        result = []
        for d1, d2 in zip(digits_a, digits_b):
            result.append(max(d1, d2))
        return result

    def lunar_product(digits_a, digits_b):
        result = [0] * (len(digits_a) + len(digits_b))
        for i, d1 in enumerate(digits_a):
            for j, d2 in enumerate(digits_b):
                result[i + j] = max(result[i + j], min(d1, d2))
        return result

    digits_a = to_digits(a)
    digits_b = to_digits(b)

    lunar_sum_digits = lunar_sum(digits_a, digits_b)
    lunar_product_digits = lunar_product(digits_a, digits_b)

    return [str(from_digits(lunar_sum_digits)), str(int(from_digits(lunar_product_digits) / 10))]


a = int(input())
b = int(input())
if (1 <= a <= 10^100) and (1 <= b):
    print(' '.join(lunar_arithmetic(a, b)))
