from collections import defaultdict, deque


def solve_warehouse_guarding():
    n, m, k = map(int, input().split())
    graph = defaultdict(list)
    for _ in range(m):
        a, b = map(int, input().split())
        graph[a].append(b)
        graph[b].append(a)
    guards = []
    for _ in range(k):
        p, h = map(int, input().split())
        guards.append((p, h))
    guarded_warehouses = set()
    for guard_pos, stamina in guards:
        visited = set()
        queue = deque([(guard_pos, 0)])
        while queue:
            curr_warehouse, distance = queue.popleft()
            if curr_warehouse in visited:
                continue
            visited.add(curr_warehouse)
            if distance > stamina:
                break
            guarded_warehouses.add(curr_warehouse)
            for neighbor in graph[curr_warehouse]:
                if neighbor not in visited:
                    queue.append((neighbor, distance + 1))
    result = sorted(list(guarded_warehouses))
    print(len(result))
    print(*result if result else '')


solve_warehouse_guarding()
