from collections import defaultdict, deque


def solve_warehouse_guarding():
    n, m, k = map(int, input().split())
    assert 1 <= n <= 2 * 10 ** 5, "Invalid number of warehouses"
    assert 1 <= m <= 2 * 10 ** 5, "Invalid number of roads"
    assert 1 <= k <= 2 * 10 ** 5, "Invalid number of guards"
    graph = defaultdict(list)
    used_roads = set()
    for _ in range(m):
        a, b = map(int, input().split())
        assert 1 <= a <= n and 1 <= b <= n, "Invalid road connection"
        assert (a, b) not in used_roads and (b, a) not in used_roads, "Duplicate road"
        graph[a].append(b)
        graph[b].append(a)
        used_roads.add((a, b))
    guard_positions = set()
    guarded_set = set()
    for _ in range(k):
        p, h = map(int, input().split())
        assert 1 <= p <= n, "Invalid guard position"
        assert p not in guard_positions, "Duplicate guard position"
        guard_positions.add(p)
        visited = set()
        queue = deque([(p, 0)])
        while queue:
            curr_warehouse, distance = queue.popleft()
            if distance > h:
                break
            if curr_warehouse in visited:
                continue
            visited.add(curr_warehouse)
            guarded_set.add(curr_warehouse)
            for neighbor in graph[curr_warehouse]:
                if neighbor not in visited:
                    queue.append((neighbor, distance + 1))
    result = sorted(list(guarded_set))
    print(len(result))
    print(*result if result else '')


solve_warehouse_guarding()
