from collections import defaultdict, deque


def solve_warehouse_guarding():
    n, m, k = map(int, input().split())
    assert 1 <= n <= 2 * 10 ** 5 and 0 <= m <= 2 * 10 ** 5 and 0 <= k <= n

    graph = defaultdict(list)
    for _ in range(m):
        a, b = map(int, input().split())
        assert 1 <= a <= n and 1 <= b <= n
        graph[a].append(b)
        graph[b].append(a)

    guarded_warehouses = set()
    for _ in range(k):
        p, h = map(int, input().split())
        assert 1 <= p <= n

        visited = set()
        queue = deque([(p, 0)])
        while queue:
            curr, dist = queue.popleft()
            if dist > h:
                break
            if curr in visited:
                continue
            visited.add(curr)
            guarded_warehouses.add(curr)
            for neighbor in graph[curr]:
                if neighbor not in visited:
                    queue.append((neighbor, dist + 1))

    result = sorted(guarded_warehouses)
    print(len(result))
    print(*result if result else '')


solve_warehouse_guarding()