from itertools import permutations
import math


def manhattan_distance(p1, p2):
    return abs(p1[0] - p2[0]) + abs(p1[1] - p2[1])


def find_shortest_path(n, coordinates):
    min_path_length = float('inf')
    for perm in permutations(coordinates):
        path_length = 0
        for i in range(n - 1):
            path_length += math.sqrt(manhattan_distance(perm[i], perm[i + 1]))
        min_path_length = min(min_path_length, path_length)

    return min_path_length


n = int(input())
coordinates = [tuple(map(int, input().split())) for _ in range(n)]
shortest_path = find_shortest_path(n, coordinates)
print(f"{shortest_path:.6f}")
