import itertools
import math


def euclidean_distance(p1, p2):
    """Вычисление евклидова расстояния между двумя точками."""
    return math.sqrt((p1[0] - p2[0]) ** 2 + (p1[1] - p2[1]) ** 2)


def find_min_route(n, points):
    """Нахождение кратчайшего маршрута для обхода всех точек."""
    min_distance = float('inf')  # Инициализируем минимальную длину бесконечностью

    # Перебираем все перестановки точек
    for perm in itertools.permutations(points):
        # Вычисляем длину текущего маршрута
        current_distance = 0
        for i in range(n - 1):
            current_distance += euclidean_distance(perm[i], perm[i + 1])

        # Обновляем минимальную длину, если нашли более короткий маршрут
        min_distance = min(min_distance, current_distance)

    return min_distance


# Чтение данных
n = int(input())
points = [tuple(map(int, input().split())) for _ in range(n)]

# Поиск минимальной длины маршрута
result = find_min_route(n, points)

# Вывод результата с точностью до 10^-6
print(result)
